---clean up schema
DROP SCHEMA IF EXISTS :schema CASCADE;

CREATE SCHEMA IF NOT EXISTS :schema;
SET search_path to :schema, public;

---get subset of stops in Germany and its states

---create views
CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de AS
SELECT * FROM :schema_gtfs.stops AS stops JOIN public.de_al2_w_ntags_smplcty10_20230818 AS de ON ST_Intersects(stops.the_geom, de.wkb_geometry) order by stop_id;

CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de_hb AS
SELECT * FROM :schema_gtfs.stops AS stops JOIN public.de_hb_al4_w_ntags_smplcty10_20230818 AS de_hb ON ST_Intersects(stops.the_geom, de_hb.wkb_geometry) order by stop_id;

CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de_hh AS
SELECT * FROM :schema_gtfs.stops AS stops JOIN public.de_hh_al4_w_ntags_smplcty10_20230818 AS de_hh ON ST_Intersects(stops.the_geom, de_hh.wkb_geometry) order by stop_id;

CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de_ni AS
SELECT * FROM :schema_gtfs.stops AS stops JOIN public.de_ni_al4_w_ntags_smplcty10_20230818 AS de_ni ON ST_Intersects(stops.the_geom, de_ni.wkb_geometry) order by stop_id;

---create tables
CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de;

CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de_hb AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de_hb;

CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de_hh AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de_hh;

CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de_ni AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de_ni;

---get subset of stops in Germany and its states that do not comply with a proper Global ID

---create views
CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de_not_dhid AS SELECT * FROM :schema.tbl_gtfs_stops_de WHERE stop_id NOT IN (SELECT dhid FROM :schema_gtfs.stops_zhv) AND stop_id NOT LIKE '%:%:%' ORDER BY stop_id;

CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de_hb_not_dhid AS SELECT * FROM :schema.tbl_gtfs_stops_de_hb WHERE stop_id NOT IN (SELECT dhid FROM :schema_gtfs.stops_zhv) AND stop_id NOT LIKE '%:%:%' ORDER BY stop_id;

CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de_hh_not_dhid AS SELECT * FROM :schema.tbl_gtfs_stops_de_hh WHERE stop_id NOT IN (SELECT dhid FROM :schema_gtfs.stops_zhv) AND stop_id NOT LIKE '%:%:%' ORDER BY stop_id;

CREATE OR REPLACE VIEW :schema.vw_gtfs_stops_de_ni_not_dhid AS SELECT * FROM :schema.tbl_gtfs_stops_de_ni WHERE stop_id NOT IN (SELECT dhid FROM :schema_gtfs.stops_zhv) AND stop_id NOT LIKE '%:%:%' ORDER BY stop_id;

---create tables
CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de_not_dhid AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de_not_dhid;

CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de_hb_not_dhid AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de_hb_not_dhid;

CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de_hh_not_dhid AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de_hh_not_dhid;

CREATE TABLE IF NOT EXISTS :schema.tbl_gtfs_stops_de_ni_not_dhid AS SELECT stop_id,stop_name,stop_lat,stop_lon,the_geom FROM :schema.vw_gtfs_stops_de_ni_not_dhid;
