import React, { useState, useEffect } from 'react'
import {Link} from 'react-router-dom';

import {
    getStopsCountGtfsDeNotDhid,
    getStopsCountGtfsDeHbNotDhid,
    getStopsCountGtfsDeHhNotDhid,
    getStopsCountGtfsDeNiNotDhid,
    getStopsCountGtfs,
    getStopsCountGtfsDe,
    getStopsCountGtfsDeHb,
    getStopsCountGtfsDeHh,
    getStopsCountGtfsDeNi
} from '../utils/api';

export default function Home(){
    const [countStopsGtfs, setCountStopsGtfs] = useState('loading...');

    const [countStopsGtfsDe, setCountStopsGtfsDe] = useState('loading...');
    const [countStopsGtfsDeHb, setCountStopsGtfsDeHb] = useState('loading...');
    const [countStopsGtfsDeHh, setCountStopsGtfsDeHh] = useState('loading...');
    const [countStopsGtfsDeNi, setCountStopsGtfsDeNi] = useState('loading...');

    const [countStopsGtfsDeNotDhid, setCountStopsGtfsDeNotDhid] = useState('loading...');
    const [countStopsGtfsDeHbNotDhid, setCountStopsGtfsDeHbNotDhid] = useState('loading...');
    const [countStopsGtfsDeHhNotDhid, setCountStopsGtfsDeHhNotDhid] = useState('loading...');
    const [countStopsGtfsDeNiNotDhid, setCountStopsGtfsDeNiNotDhid] = useState('loading...');

    /*fetch countStopsGtfs in a JavaScript function*/
    const fetchGtfs = async () => {
	let count=await getStopsCountGtfs();
	if(count > -1){
	    setCountStopsGtfs((countStopsGtfs) => count);
	}
    };

    /*fetch countStopsGtfsDe in a JavaScript function*/
    const fetchGtfsDe = async () => {
	let count=await getStopsCountGtfsDe();
	if(count > -1){
	    setCountStopsGtfsDe((countStopsGtfsDe) => count);
	}
    };

    /*fetch countStopsGtfsDeHb in a JavaScript function*/
    const fetchGtfsDeHb = async () => {
	let count=await getStopsCountGtfsDeHb();
	if(count > -1){
	    setCountStopsGtfsDeHb((countStopsGtfsDeHb) => count);
	}
    };

    /*fetch countStopsGtfsDeHh in a JavaScript function*/
    const fetchGtfsDeHh = async () => {
	let count=await getStopsCountGtfsDeHh();
	if(count > -1){
	    setCountStopsGtfsDeHh((countStopsGtfsDeHh) => count);
	}
    };

    /*fetch countStopsGtfsDeNi in a JavaScript function*/
    const fetchGtfsDeNi = async () => {
	let count=await getStopsCountGtfsDeNi();
	if(count > -1){
	    setCountStopsGtfsDeNi((countStopsGtfsDeNi) => count);
	}
    };

    /*fetch countStopsGtfsDeNotDhid in a JavaScript function*/
    const fetchGtfsDeNotDhid = async () => {
	let count=await getStopsCountGtfsDeNotDhid();
	if(count > -1){
	    setCountStopsGtfsDeNotDhid((countStopsGtfsDeNotDhid) => count);
	}
    };

    /*fetch countStopsGtfsDeHbNotDhid in a JavaScript function*/
    const fetchGtfsDeHbNotDhid = async () => {
	let count=await getStopsCountGtfsDeHbNotDhid();
	if(count > -1){
	    setCountStopsGtfsDeHbNotDhid((countStopsGtfsDeHbNotDhid) => count);
	}
    };

    /*fetch countStopsGtfsDeHhNotDhid in a JavaScript function*/
    const fetchGtfsDeHhNotDhid = async () => {
	let count=await getStopsCountGtfsDeHhNotDhid();
	if(count > -1){
	    setCountStopsGtfsDeHhNotDhid((countStopsGtfsDeHhNotDhid) => count);
	}
    };

    /*fetch countStopsGtfsDeNiNotDhid in a JavaScript function*/
    const fetchGtfsDeNiNotDhid = async () => {
	let count=await getStopsCountGtfsDeNiNotDhid();
	if(count > -1){
	    setCountStopsGtfsDeNiNotDhid((countStopsGtfsDeNiNotDhid) => count);
	}
    };

    useEffect(() => {
	/*effect goes here*/

	fetchGtfs();
	fetchGtfsDe();
	fetchGtfsDeHb();
	fetchGtfsDeHh();
	fetchGtfsDeNi();

	fetchGtfsDeNotDhid();
	fetchGtfsDeHbNotDhid();
	fetchGtfsDeHhNotDhid();
	fetchGtfsDeNiNotDhid();
	/*use an empty dependency countStopsGtfs to ensure the hook is running only once*/
	/*TODO study dependency countStopsGtfs: https://reactjs.org/docs/hooks-effect.html*/
    }, []);

    return (
	<>
	    <p>
		Number of stops:&nbsp;
		{countStopsGtfs}
	    </p>
	    <p>
		Number of stops inside DE:&nbsp;
		{countStopsGtfsDe}
	    </p>
	    <p>
		Number of stops inside DE not compliant with the Global ID:&nbsp;
		{countStopsGtfsDeNotDhid}
	    </p>
	    <p>
		Number of stops inside DE-HB:&nbsp;
		{countStopsGtfsDeHb}
	    </p>
	    <p>
		Number of stops inside DE-HB not compliant with the Global ID:&nbsp;
		{countStopsGtfsDeHbNotDhid} ({countStopsGtfsDeHb !== 0 ? (countStopsGtfsDeHbNotDhid / countStopsGtfsDeHb * 100).toFixed(2) : 'loading...'} %)
	    </p>
	    <p>
		Number of stops inside DE-HH:&nbsp;
		{countStopsGtfsDeHh}
	    </p>
	    <p>
		Number of stops inside DE-HH not compliant with the Global ID:&nbsp;
		{countStopsGtfsDeHhNotDhid} ({countStopsGtfsDeHh !== 0 ? (countStopsGtfsDeHhNotDhid / countStopsGtfsDeHh * 100).toFixed(2) : 'loading...'} %)
	    </p>
	    <p>
		Number of stops inside DE-NI:&nbsp;
		{countStopsGtfsDeNi}
	    </p>
	    <p>
		Number of stops inside DE-NI not compliant with the Global ID:&nbsp;
		{countStopsGtfsDeNiNotDhid} ({countStopsGtfsDeNi !== 0 ? (countStopsGtfsDeNiNotDhid / countStopsGtfsDeNi * 100).toFixed(2) : 'loading...'} %)
	    </p>
	    <h3>
	    <Link to="/stops-non-compliant">
		Browse through stops inside DE not compliant with the Global ID.
	    </Link>
	    </h3>
	    <h3>
	    <Link to="/stops-refined">
		Browse through stops inside DE refined to be compliant with the Global ID.
	    </Link>
	    </h3>
	</>
    );
}
